
Core - Task # 53747

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Bug # 52949 (Resolved): Speed decrease since 4.5

Status: Resolved Priority: Should have
Author: Thomas Maroschik Category: Caching
Created: 2013-11-18 Assigned To: Thomas Maroschik
Updated: 2013-11-21 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: medium
Subject: Change TCA cache from php code to serialized array
Description

Related issues:
related to Core - Bug # 51116: Massive speed problem from TYPO3 version 6.x a... Resolved 2013-08-16
related to Core - Story # 55075: review TCA cache and increase performance an... Closed 2014-01-16

Associated revisions
Revision ede0978c - 2013-11-21 10:55 - Thomas Maroschik

[TASK] Replace TCA cache with serialized array

The TCA isn't stored as php array anymore,
but instead as serialized array string. Unserialize
seems to be much faster in this regard although
opcode caches have been tested.

Resolves: #53747
Releases: 6.2
Change-Id: I540cae2ecee0ef09635ceff0b91b7a940dae01f7
Reviewed-on: https://review.typo3.org/25492
Reviewed-by: Alexander Opitz
Tested-by: Alexander Opitz
Reviewed-by: Markus Klein
Tested-by: Markus Klein
Reviewed-by: Thomas Maroschik
Tested-by: Thomas Maroschik

History
#1 - 2013-11-18 23:00 - Markus Klein
- Category set to Caching

#2 - 2013-11-18 23:01 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25492
#3 - 2013-11-19 08:44 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25492

#4 - 2013-11-19 09:51 - Bernhard Kraft

I would suggest to rather create a global var:

$GLOBALS['TCA'] = GeneralUtility::makeInstance('TYPO3\CMS\Core\WHATEVER\DatabaseBackedArray');

and create the appropriate class like

class DatabaseBackedArray implements arrayaccess {

according to the PHP docs:
http://php.net/manual/en/class.arrayaccess.php

Then it would be possible to load required parts of TYPO3_CONF_VARS and/or TCA just on requirement from the DB (or eventually store it in a
memcached, etc. Cache backend)

#5 - 2013-11-19 10:00 - Thomas Maroschik

Hello Bernhard,

we already thought of that, but it should be discussed in an own issue. It has nothing to do with the bare switch of the caching technique and is a
discussion about the general handling of the TCA. Please open a new issue and remove your -1 on the patch.

#6 - 2013-11-19 10:36 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25492

#7 - 2013-11-19 13:07 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25492

#8 - 2013-11-19 13:22 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25492

#9 - 2013-11-21 11:30 - Thomas Maroschik
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ede0978c321ee3a42d08bd457463b20208c23826.
